// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UObject.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UField : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UField() = default;

		virtual bool GetBoolMetaData(const wstring& Key) const = 0;

		virtual wstring GetMetaData(const wstring& Key) const = 0;

		virtual shared_ptr<class ISCW_UClass> GetOwnerClass() const = 0;

		virtual bool HasMetaData(const wstring& Key) const = 0;
		
		virtual bool IsValidLowLevel() const = 0;

		virtual shared_ptr<ISCW_UField> ToUFieldPtr() = 0;

		virtual shared_ptr<const ISCW_UField> ToUFieldPtr() const = 0;
	};

	using ISCW_UFieldPtr = shared_ptr<ISCW_UField>;
	using ISCW_UFieldConstPtr = shared_ptr<const ISCW_UField>;

} // namespace Sourcify